---
title: 'RTCPeerConnection: addstream event'
slug: Web/API/RTCPeerConnection/addstream_event
tags:
  - Event
  - Media
  - MediaStream
  - Obsolete
  - RTCPeerConnection
  - Reference
  - Streams
  - WebRTC
  - WebRTC API
  - addStream
  - events
---
<p>{{WebRTCSidebar}}{{obsolete_header}}</p>

<p>The obsolete <code><strong>addstream</strong></code> event is sent to an {{domxref("RTCPeerConnection")}} when new media, in the form of a {{domxref("MediaStream")}} object, has been added to it.</p>

<div class="notecard warning">
<p><strong>Important:</strong> This event has been removed from the WebRTC specification. You should instead watch for the {{domxref("RTCPeerConnection.track_event", "track")}} event, which is sent for each media track added to the <code>RTCPeerConnection</code>.</p>
</div>

<table class="properties">
 <tbody>
  <tr>
   <th scope="row">Bubbles</th>
   <td>No</td>
  </tr>
  <tr>
   <th scope="row">Cancelable</th>
   <td>No</td>
  </tr>
  <tr>
   <th scope="row">Interface</th>
   <td>{{DOMxRef("MediaStreamEvent")}}</td>
  </tr>
  <tr>
   <th scope="row">Event handler property</th>
   <td>{{DOMxRef("RTCPeerconnection.onaddstream")}}</td>
  </tr>
 </tbody>
</table>

<p>You can, similarly, watch for streams to be removed from the connection by monitoring the {{domxref("RTCPeerConnection.removestream_event", "removestream")}} event.</p>

<h2 id="Examples">Examples</h2>

<p>This example looks to determine if the user's browser supports the {{domxref("RTCPeerConnection.track_event", "track")}} event. If it does, a <code>track</code> event listener is set up; otherwise, an <code>addstream</code> event listener is set up. <code>pc</code> is an <code>RTCPeerConnection</code>.</p>

<pre class="brush: js">if (pc.addTrack !== undefined) {
  pc.ontrack = ev =&gt; {
    ev.streams.forEach(stream =&gt; doAddStream(stream));
  }
} else {
  pc.onaddstream = ev =&gt; {
    doAddStream(ev.stream);
  }
}
</pre>

<p>This calls a function <code>doAddStream()</code> once for each stream being added to the {{domxref("RTCPeerConnection")}}, regardless of whether the browser sends <code>addstream</code> or <code>track</code>.</p>

<p>You can also use the {{domxref("EventTarget.addEventListener", "addEventListener()")}} method to set an event listener:</p>

<pre class="brush: js">pc.addEventListener("addstream", ev =&gt; doAddStream(ev.stream), false);</pre>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.RTCPeerConnection.addstream_event")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/WebRTC_API">WebRTC API</a></li>
 <li>{{domxref("RTCPeerConnection.onaddstream")}}</li>
 <li>{{domxref("RTCPeerConnection.addStream()")}}</li>
 <li>{{domxref("MediaStreamEvent")}}</li>
</ul>
